/[gentoo-x86]/eclass/python.eclass
Gentoo

Diff of /eclass/python.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.57 Revision 1.84
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2010 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/python.eclass,v 1.57 2009/08/02 16:56:41 arfrever Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/python.eclass,v 1.84 2010/01/11 16:07:23 arfrever Exp $
4 4
5# @ECLASS: python.eclass 5# @ECLASS: python.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# python@gentoo.org 7# python@gentoo.org
8#
9# original author: Alastair Tse <liquidx@gentoo.org>
10# @BLURB: A Utility Eclass that should be inherited by anything that deals with Python or Python modules. 8# @BLURB: A utility eclass that should be inherited by anything that deals with Python or Python modules.
11# @DESCRIPTION: 9# @DESCRIPTION:
12# Some useful functions for dealing with python. 10# Some useful functions for dealing with Python.
13inherit alternatives multilib
14 11
12inherit multilib
15 13
14if ! has "${EAPI:-0}" 0 1 2; then
15 die "API of python.eclass in EAPI=\"${EAPI}\" not established"
16fi
17
16if [[ -n "${NEED_PYTHON}" ]] ; then 18if [[ -n "${NEED_PYTHON}" ]]; then
17 PYTHON_ATOM=">=dev-lang/python-${NEED_PYTHON}" 19 PYTHON_ATOM=">=dev-lang/python-${NEED_PYTHON}"
18 DEPEND="${PYTHON_ATOM}" 20 DEPEND="${PYTHON_ATOM}"
19 RDEPEND="${DEPEND}" 21 RDEPEND="${DEPEND}"
20else 22else
21 PYTHON_ATOM="dev-lang/python" 23 PYTHON_ATOM="dev-lang/python"
22fi 24fi
23 25
24if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
25 DEPEND="${DEPEND} >=app-admin/eselect-python-20090801" 26DEPEND+=" >=app-admin/eselect-python-20090804"
26fi
27 27
28__python_eclass_test() { 28__python_eclass_test() {
29 __python_version_extract 2.3 29 __python_version_extract 2.3
30 echo -n "2.3 -> PYVER: $PYVER PYVER_MAJOR: $PYVER_MAJOR" 30 echo -n "2.3 -> PYVER: $PYVER PYVER_MAJOR: $PYVER_MAJOR"
31 echo " PYVER_MINOR: $PYVER_MINOR PYVER_MICRO: $PYVER_MICRO" 31 echo " PYVER_MINOR: $PYVER_MINOR PYVER_MICRO: $PYVER_MICRO"
59 59
60python_version() { 60python_version() {
61 [[ -n "${PYVER}" ]] && return 0 61 [[ -n "${PYVER}" ]] && return 0
62 local tmpstr 62 local tmpstr
63 python=${python:-/usr/bin/python} 63 python=${python:-/usr/bin/python}
64 tmpstr="$(${python} -V 2>&1 )" 64 tmpstr="$(EPYTHON= ${python} -V 2>&1 )"
65 export PYVER_ALL="${tmpstr#Python }" 65 export PYVER_ALL="${tmpstr#Python }"
66 __python_version_extract $PYVER_ALL 66 __python_version_extract $PYVER_ALL
67} 67}
68 68
69# @FUNCTION: get_python 69# @FUNCTION: PYTHON
70# @USAGE: [-a|--absolute-path] <Python_ABI="${PYTHON_ABI}"> 70# @USAGE: [-2] [-3] [--ABI] [-A|--active] [-a|--absolute-path] [-f|--final-ABI] [--] <Python_ABI="${PYTHON_ABI}">
71# @DESCRIPTION: 71# @DESCRIPTION:
72# Get Python interpreter filename for specified Python ABI. If Python_ABI argument 72# Get Python interpreter filename for specified Python ABI. If Python_ABI argument
73# is ommitted, then PYTHON_ABI environment variable must be set and is used. 73# is ommitted, then PYTHON_ABI environment variable must be set and is used.
74get_python() { 74# If -2 option is specified, then active version of Python 2 is used.
75 local absolute_path="0" slot= 75# If -3 option is specified, then active version of Python 3 is used.
76# If --active option is specified, then active version of Python is used.
77# Active version of Python can be set by python_set_active_version().
78# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
79# -2, -3, --active and --final-ABI options and Python_ABI argument cannot be specified simultaneously.
80# If --ABI option is specified, then only specified Python ABI is printed instead of
81# Python interpreter filename.
82# --ABI and --absolute-path options cannot be specified simultaneously.
83PYTHON() {
84 local ABI_output="0" absolute_path_output="0" active="0" final_ABI="0" python2="0" python3="0" slot=
76 85
77 while (($#)); do 86 while (($#)); do
78 case "$1" in 87 case "$1" in
88 -2)
89 python2="1"
90 ;;
91 -3)
92 python3="1"
93 ;;
94 --ABI)
95 ABI_output="1"
96 ;;
97 -A|--active)
98 active="1"
99 ;;
79 -a|--absolute-path) 100 -a|--absolute-path)
80 absolute_path="1" 101 absolute_path_output="1"
102 ;;
103 -f|--final-ABI)
104 final_ABI="1"
105 ;;
106 --)
107 break
81 ;; 108 ;;
82 -*) 109 -*)
83 die "${FUNCNAME}(): Unrecognized option $1" 110 die "${FUNCNAME}(): Unrecognized option '$1'"
84 ;; 111 ;;
85 *) 112 *)
86 break 113 break
87 ;; 114 ;;
88 esac 115 esac
89 shift 116 shift
90 done 117 done
91 118
119 if [[ "${ABI_output}" == "1" && "${absolute_path_output}" == "1" ]]; then
120 die "${FUNCNAME}(): '--ABI and '--absolute-path' options cannot be specified simultaneously"
121 fi
122
123 if [[ "$((${python2} + ${python3} + ${active} + ${final_ABI}))" -gt 1 ]]; then
124 die "${FUNCNAME}(): '-2', '-3', '--active' or '--final-ABI' options cannot be specified simultaneously"
125 fi
126
92 if [[ "$#" -eq "0" ]]; then 127 if [[ "$#" -eq 0 ]]; then
128 if [[ "${active}" == "1" ]]; then
129 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
130 die "${FUNCNAME}(): '--active' option cannot be used in ebuilds of packages supporting installation for multiple versions of Python"
131 fi
132 slot="$(/usr/bin/python -c 'from sys import version_info; print(".".join([str(x) for x in version_info[:2]]))')"
133 elif [[ "${final_ABI}" == "1" ]]; then
134 validate_PYTHON_ABIS
135 slot="${PYTHON_ABIS##* }"
136 elif [[ "${python2}" == "1" ]]; then
137 slot="$(eselect python show --python2)"
138 if [[ -z "${slot}" ]]; then
139 die "${FUNCNAME}(): Active Python 2 interpreter not set"
140 elif [[ "${slot}" != "python2."* ]]; then
141 die "${FUNCNAME}(): Internal error in \`eselect python show --python2\`"
142 fi
143 slot="${slot#python}"
144 elif [[ "${python3}" == "1" ]]; then
145 slot="$(eselect python show --python3)"
146 if [[ -z "${slot}" ]]; then
147 die "${FUNCNAME}(): Active Python 3 interpreter not set"
148 elif [[ "${slot}" != "python3."* ]]; then
149 die "${FUNCNAME}(): Internal error in \`eselect python show --python3\`"
150 fi
151 slot="${slot#python}"
93 if [[ -n "${PYTHON_ABI}" ]]; then 152 elif [[ -n "${PYTHON_ABI}" ]]; then
94 slot="${PYTHON_ABI}" 153 slot="${PYTHON_ABI}"
95 else 154 else
96 die "${FUNCNAME}(): Invalid usage" 155 die "${FUNCNAME}(): Invalid usage"
97 fi 156 fi
98 elif [[ "$#" -eq "1" ]]; then 157 elif [[ "$#" -eq 1 ]]; then
158 if [[ "${active}" == "1" ]]; then
159 die "${FUNCNAME}(): '--active' option and Python ABI cannot be specified simultaneously"
160 fi
161 if [[ "${final_ABI}" == "1" ]]; then
162 die "${FUNCNAME}(): '--final-ABI' option and Python ABI cannot be specified simultaneously"
163 fi
164 if [[ "${python2}" == "1" ]]; then
165 die "${FUNCNAME}(): '-2' option and Python ABI cannot be specified simultaneously"
166 fi
167 if [[ "${python3}" == "1" ]]; then
168 die "${FUNCNAME}(): '-3' option and Python ABI cannot be specified simultaneously"
169 fi
99 slot="$1" 170 slot="$1"
100 else 171 else
101 die "${FUNCNAME}(): Invalid usage" 172 die "${FUNCNAME}(): Invalid usage"
102 fi 173 fi
103 174
175 if [[ "${ABI_output}" == "1" ]]; then
176 echo -n "${slot}"
177 return
104 if [[ "${absolute_path}" == "1" ]]; then 178 elif [[ "${absolute_path_output}" == "1" ]]; then
105 echo -n "/usr/bin/python${slot}" 179 echo -n "/usr/bin/python${slot}"
106 else 180 else
107 echo -n "python${slot}" 181 echo -n "python${slot}"
108 fi 182 fi
183
184 if [[ -n "${ABI}" && "${ABI}" != "${DEFAULT_ABI}" && "${DEFAULT_ABI}" != "default" ]]; then
185 echo -n "-${ABI}"
186 fi
109} 187}
188
189_python_implementation() {
190 if [[ "${CATEGORY}/${PN}" == "dev-lang/python" ]]; then
191 return 0
192 else
193 return 1
194 fi
195}
196
197# @FUNCTION: python_set_active_version
198# @USAGE: <Python_ABI|2|3>
199# @DESCRIPTION:
200# Set active version of Python.
201python_set_active_version() {
202 if [[ "$#" -ne "1" ]]; then
203 die "${FUNCNAME}() requires 1 argument"
204 fi
205
206 if [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then
207 if ! _python_implementation && ! has_version "dev-lang/python:$1"; then
208 die "${FUNCNAME}(): 'dev-lang/python:$1' is not installed"
209 fi
210 export EPYTHON="$(PYTHON "$1")"
211 elif [[ "$1" == "2" ]]; then
212 if ! _python_implementation && ! has_version "=dev-lang/python-2*"; then
213 die "${FUNCNAME}(): '=dev-lang/python-2*' is not installed"
214 fi
215 export EPYTHON="$(PYTHON -2)"
216 elif [[ "$1" == "3" ]]; then
217 if ! _python_implementation && ! has_version "=dev-lang/python-3*"; then
218 die "${FUNCNAME}(): '=dev-lang/python-3*' is not installed"
219 fi
220 export EPYTHON="$(PYTHON -3)"
221 else
222 die "${FUNCNAME}(): Unrecognized argument '$1'"
223 fi
224
225 # PYTHON_ABI variable is intended to be used only in ebuilds/eclasses,
226 # so it does not need to be exported to subprocesses.
227 PYTHON_ABI="${EPYTHON#python}"
228 PYTHON_ABI="${PYTHON_ABI%%-*}"
229}
230
231unset PYTHON_ABIS
232unset PYTHON_ABIS_SANITY_CHECKS
110 233
111# @FUNCTION: validate_PYTHON_ABIS 234# @FUNCTION: validate_PYTHON_ABIS
112# @DESCRIPTION: 235# @DESCRIPTION:
113# Make sure PYTHON_ABIS variable has valid value. 236# Ensure that PYTHON_ABIS variable has valid value.
114validate_PYTHON_ABIS() { 237validate_PYTHON_ABIS() {
238 # Ensure that some functions cannot be accidentally successfully used in EAPI <= 2 without setting SUPPORT_PYTHON_ABIS variable.
239 if has "${EAPI:-0}" 0 1 2 && [[ -z "${SUPPORT_PYTHON_ABIS}" ]]; then
240 die "${FUNCNAME}() cannot be used in this EAPI without setting SUPPORT_PYTHON_ABIS variable"
241 fi
242
115 # Ensure that /usr/bin/python and /usr/bin/python-config are scripts. 243 # Ensure that /usr/bin/python and /usr/bin/python-config are valid.
116 if [[ "$(</usr/bin/python)" != *"Gentoo Python wrapper script"* ]]; then 244 if [[ "$(readlink /usr/bin/python)" != "python-wrapper" ]]; then
245 eerror "'/usr/bin/python' is not valid symlink."
246 eerror "Use \`eselect python set \${python_interpreter}\` to fix this problem."
117 die "/usr/bin/python isn't valid script" 247 die "'/usr/bin/python' is not valid symlink"
118 fi 248 fi
119 if [[ "$(</usr/bin/python-config)" != *"Gentoo python-config wrapper script"* ]]; then 249 if [[ "$(</usr/bin/python-config)" != *"Gentoo python-config wrapper script"* ]]; then
250 eerror "'/usr/bin/python-config' is not valid script"
251 eerror "Use \`eselect python set \${python_interpreter}\` to fix this problem."
120 die "/usr/bin/python-config isn't valid script" 252 die "'/usr/bin/python-config' is not valid script"
121 fi 253 fi
122 254
123 # USE_${ABI_TYPE^^} and RESTRICT_${ABI_TYPE^^}_ABIS variables hopefully will be included in EAPI >= 4. 255 # USE_${ABI_TYPE^^} and RESTRICT_${ABI_TYPE^^}_ABIS variables hopefully will be included in EAPI >= 5.
124 if [[ -z "${PYTHON_ABIS}" ]] && has "${EAPI:-0}" 0 1 2 3; then 256 if [[ "$(declare -p PYTHON_ABIS 2> /dev/null)" != "declare -x PYTHON_ABIS="* ]] && has "${EAPI:-0}" 0 1 2 3 4; then
125 local ABI support_ABI supported_PYTHON_ABIS= restricted_ABI 257 local PYTHON_ABI python2_supported_versions python3_supported_versions restricted_ABI support_ABI supported_PYTHON_ABIS=
126 PYTHON_ABI_SUPPORTED_VALUES="2.4 2.5 2.6 2.7 3.0 3.1 3.2" 258 PYTHON_ABI_SUPPORTED_VALUES="2.4 2.5 2.6 2.7 3.0 3.1 3.2"
259 python2_supported_versions="2.4 2.5 2.6 2.7"
260 python3_supported_versions="3.0 3.1 3.2"
261
262 if [[ "$(declare -p USE_PYTHON 2> /dev/null)" == "declare -x USE_PYTHON="* ]]; then
263 local python2_enabled="0" python3_enabled="0"
264
265 if [[ -z "${USE_PYTHON}" ]]; then
266 die "USE_PYTHON variable is empty"
267 fi
268
127 for ABI in ${USE_PYTHON}; do 269 for PYTHON_ABI in ${USE_PYTHON}; do
128 if ! has "${ABI}" ${PYTHON_ABI_SUPPORTED_VALUES}; then 270 if ! has "${PYTHON_ABI}" ${PYTHON_ABI_SUPPORTED_VALUES}; then
129 ewarn "Ignoring unsupported Python ABI '${ABI}'" 271 die "USE_PYTHON variable contains invalid value '${PYTHON_ABI}'"
130 continue
131 fi 272 fi
273
274 if has "${PYTHON_ABI}" ${python2_supported_versions}; then
275 python2_enabled="1"
276 fi
277 if has "${PYTHON_ABI}" ${python3_supported_versions}; then
278 python3_enabled="1"
279 fi
280
132 support_ABI="1" 281 support_ABI="1"
133 for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do 282 for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do
134 if python -c "from fnmatch import fnmatch; exit(not fnmatch('${ABI}', '${restricted_ABI}'))"; then 283 if [[ "${PYTHON_ABI}" == ${restricted_ABI} ]]; then
135 support_ABI="0" 284 support_ABI="0"
136 break 285 break
137 fi 286 fi
287 done
288 [[ "${support_ABI}" == "1" ]] && export PYTHON_ABIS+="${PYTHON_ABIS:+ }${PYTHON_ABI}"
138 done 289 done
139 [[ "${support_ABI}" == "1" ]] && supported_PYTHON_ABIS+=" ${ABI}" 290
291 if [[ -z "${PYTHON_ABIS//[${IFS}]/}" ]]; then
292 die "USE_PYTHON variable does not enable any version of Python supported by ${CATEGORY}/${PF}"
293 fi
294
295 if [[ "${python2_enabled}" == "0" ]]; then
296 ewarn "USE_PYTHON variable does not enable any version of Python 2. This configuration is unsupported."
297 fi
298 if [[ "${python3_enabled}" == "0" ]]; then
299 ewarn "USE_PYTHON variable does not enable any version of Python 3. This configuration is unsupported."
300 fi
301 else
302 local python_version python2_version= python3_version= support_python_major_version
303
304 python_version="$(/usr/bin/python -c 'from sys import version_info; print(".".join([str(x) for x in version_info[:2]]))')"
305
306 if has_version "=dev-lang/python-2*"; then
307 if [[ "$(readlink /usr/bin/python2)" != "python2."* ]]; then
308 die "'/usr/bin/python2' is not valid symlink"
309 fi
310
311 python2_version="$(/usr/bin/python2 -c 'from sys import version_info; print(".".join([str(x) for x in version_info[:2]]))')"
312
313 for PYTHON_ABI in ${python2_supported_versions}; do
314 support_python_major_version="1"
315 for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do
316 if [[ "${PYTHON_ABI}" == ${restricted_ABI} ]]; then
317 support_python_major_version="0"
318 fi
319 done
320 [[ "${support_python_major_version}" == "1" ]] && break
321 done
322 if [[ "${support_python_major_version}" == "1" ]]; then
323 for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do
324 if [[ "${python2_version}" == ${restricted_ABI} ]]; then
325 die "Active version of Python 2 is not supported by ${CATEGORY}/${PF}"
326 fi
327 done
328 else
329 python2_version=""
330 fi
331 fi
332
333 if has_version "=dev-lang/python-3*"; then
334 if [[ "$(readlink /usr/bin/python3)" != "python3."* ]]; then
335 die "'/usr/bin/python3' is not valid symlink"
336 fi
337
338 python3_version="$(/usr/bin/python3 -c 'from sys import version_info; print(".".join([str(x) for x in version_info[:2]]))')"
339
340 for PYTHON_ABI in ${python3_supported_versions}; do
341 support_python_major_version="1"
342 for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do
343 if [[ "${PYTHON_ABI}" == ${restricted_ABI} ]]; then
344 support_python_major_version="0"
345 fi
346 done
347 [[ "${support_python_major_version}" == "1" ]] && break
348 done
349 if [[ "${support_python_major_version}" == "1" ]]; then
350 for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do
351 if [[ "${python3_version}" == ${restricted_ABI} ]]; then
352 die "Active version of Python 3 is not supported by ${CATEGORY}/${PF}"
353 fi
354 done
355 else
356 python3_version=""
357 fi
358 fi
359
360 if [[ -n "${python2_version}" && "${python_version}" == "2."* && "${python_version}" != "${python2_version}" ]]; then
361 eerror "Python wrapper is configured incorrectly or /usr/bin/python2 symlink"
362 eerror "is set incorrectly. Use \`eselect python\` to fix configuration."
363 die "Incorrect configuration of Python"
364 fi
365 if [[ -n "${python3_version}" && "${python_version}" == "3."* && "${python_version}" != "${python3_version}" ]]; then
366 eerror "Python wrapper is configured incorrectly or /usr/bin/python3 symlink"
367 eerror "is set incorrectly. Use \`eselect python\` to fix configuration."
368 die "Incorrect configuration of Python"
369 fi
370
371 PYTHON_ABIS="${python2_version} ${python3_version}"
372 PYTHON_ABIS="${PYTHON_ABIS# }"
373 export PYTHON_ABIS="${PYTHON_ABIS% }"
374 fi
375 fi
376
377 if ! _python_implementation && [[ "$(declare -p PYTHON_ABIS_SANITY_CHECKS 2> /dev/null)" != "declare -- PYTHON_ABIS_SANITY_CHECKS="* ]]; then
378 local PYTHON_ABI
379 for PYTHON_ABI in ${PYTHON_ABIS}; do
380 # Ensure that appropriate version of Python is installed.
381 if ! has_version "dev-lang/python:${PYTHON_ABI}"; then
382 die "dev-lang/python:${PYTHON_ABI} is not installed"
383 fi
384
385 # Ensure that EPYTHON variable is respected.
386 if [[ "$(EPYTHON="$(PYTHON)" python -c 'from sys import version_info; print(".".join([str(x) for x in version_info[:2]]))')" != "${PYTHON_ABI}" ]]; then
387 eerror "python: '$(type -p python)'"
388 eerror "ABI: '${ABI}'"
389 eerror "DEFAULT_ABI: '${DEFAULT_ABI}'"
390 eerror "EPYTHON: '$(PYTHON)'"
391 eerror "PYTHON_ABI: '${PYTHON_ABI}'"
392 eerror "Version of enabled Python: '$(EPYTHON="$(PYTHON)" python -c 'from sys import version_info; print(".".join([str(x) for x in version_info[:2]]))')'"
393 die "'python' does not respect EPYTHON variable"
394 fi
140 done 395 done
141 export PYTHON_ABIS="${supported_PYTHON_ABIS# }" 396 PYTHON_ABIS_SANITY_CHECKS="1"
142 fi
143
144 if [[ -z "${PYTHON_ABIS//[${IFS}]/}" ]]; then
145 python_version
146 export PYTHON_ABIS="${PYVER}"
147 fi 397 fi
148} 398}
149 399
150# @FUNCTION: python_copy_sources 400# @FUNCTION: python_copy_sources
151# @USAGE: [directory] 401# @USAGE: [--no-link] [--] [directory]
152# @DESCRIPTION: 402# @DESCRIPTION:
153# Copy unpacked sources of given package for each Python ABI. 403# Copy unpacked sources of given package for each Python ABI.
154python_copy_sources() { 404python_copy_sources() {
155 local dir dirs=() PYTHON_ABI 405 local dir dirs=() no_link="0" PYTHON_ABI
156 406
407 while (($#)); do
408 case "$1" in
409 --no-link)
410 no_link="1"
411 ;;
412 --)
413 break
414 ;;
415 -*)
416 die "${FUNCNAME}(): Unrecognized option '$1'"
417 ;;
418 *)
419 break
420 ;;
421 esac
422 shift
423 done
424
157 if [[ "$#" -eq "0" ]]; then 425 if [[ "$#" -eq 0 ]]; then
158 if [[ "${WORKDIR}" == "${S}" ]]; then 426 if [[ "${WORKDIR}" == "${S}" ]]; then
159 die "${FUNCNAME}() cannot be used" 427 die "${FUNCNAME}() cannot be used"
160 fi 428 fi
161 dirs="${S}" 429 dirs="${S}"
162 else 430 else
164 fi 432 fi
165 433
166 validate_PYTHON_ABIS 434 validate_PYTHON_ABIS
167 for PYTHON_ABI in ${PYTHON_ABIS}; do 435 for PYTHON_ABI in ${PYTHON_ABIS}; do
168 for dir in "${dirs[@]}"; do 436 for dir in "${dirs[@]}"; do
437 if [[ "${no_link}" == "1" ]]; then
438 cp -pr "${dir}" "${dir}-${PYTHON_ABI}" > /dev/null || die "Copying of sources failed"
439 else
169 cp -lpr "${dir}" "${dir}-${PYTHON_ABI}" > /dev/null || die "Copying of sources failed" 440 cp -lpr "${dir}" "${dir}-${PYTHON_ABI}" > /dev/null || die "Copying of sources failed"
441 fi
170 done 442 done
171 done 443 done
172} 444}
173 445
174# @FUNCTION: python_set_build_dir_symlink 446# @FUNCTION: python_set_build_dir_symlink
176# @DESCRIPTION: 448# @DESCRIPTION:
177# Create build directory symlink. 449# Create build directory symlink.
178python_set_build_dir_symlink() { 450python_set_build_dir_symlink() {
179 local dir="$1" 451 local dir="$1"
180 452
181 [[ -z "${PYTHON_ABIS}" ]] && die "PYTHON_ABIS variable not set" 453 [[ -z "${PYTHON_ABI}" ]] && die "PYTHON_ABI variable not set"
182 [[ -z "${dir}" ]] && dir="build" 454 [[ -z "${dir}" ]] && dir="build"
183 455
184 # Don't delete preexistent directories. 456 # Do not delete preexistent directories.
185 rm -f "${dir}" || die "Deletion of '${dir}' failed" 457 rm -f "${dir}" || die "Deletion of '${dir}' failed"
186 ln -s "${dir}-${PYTHON_ABI}" "${dir}" || die "Creation of '${dir}' directory symlink failed" 458 ln -s "${dir}-${PYTHON_ABI}" "${dir}" || die "Creation of '${dir}' directory symlink failed"
187} 459}
188 460
189# @FUNCTION: python_execute_function 461# @FUNCTION: python_execute_function
190# @USAGE: [--action-message message] [--failure-message message] [--nonfatal] [-q|--quiet] [-s|--separate-build-dirs] <function> [arguments] 462# @USAGE: [--action-message message] [-d|--default-function] [--failure-message message] [--nonfatal] [-q|--quiet] [-s|--separate-build-dirs] [--source-dir source_directory] [--] <function> [arguments]
191# @DESCRIPTION: 463# @DESCRIPTION:
192# Execute specified function for each value of PYTHON_ABIS, optionally passing 464# Execute specified function for each value of PYTHON_ABIS, optionally passing additional
193# additional arguments. The specified function can use PYTHON_ABI variable. 465# arguments. The specified function can use PYTHON_ABI and BUILDDIR variables.
194python_execute_function() { 466python_execute_function() {
195 local action action_message action_message_template= failure_message failure_message_template= function nonfatal="0" PYTHON_ABI quiet="0" separate_build_dirs="0" 467 local action action_message action_message_template= default_function="0" failure_message failure_message_template= function nonfatal="0" previous_directory previous_directory_stack previous_directory_stack_length PYTHON_ABI quiet="0" separate_build_dirs="0" source_dir=
196 468
197 while (($#)); do 469 while (($#)); do
198 case "$1" in 470 case "$1" in
199 --action-message) 471 --action-message)
200 action_message_template="$2" 472 action_message_template="$2"
201 shift 473 shift
202 ;; 474 ;;
475 -d|--default-function)
476 default_function="1"
477 ;;
203 --failure-message) 478 --failure-message)
204 failure_message_template="$2" 479 failure_message_template="$2"
205 shift 480 shift
206 ;; 481 ;;
207 --nonfatal) 482 --nonfatal)
211 quiet="1" 486 quiet="1"
212 ;; 487 ;;
213 -s|--separate-build-dirs) 488 -s|--separate-build-dirs)
214 separate_build_dirs="1" 489 separate_build_dirs="1"
215 ;; 490 ;;
491 --source-dir)
492 source_dir="$2"
493 shift
494 ;;
495 --)
496 break
497 ;;
216 -*) 498 -*)
217 die "${FUNCNAME}(): Unrecognized option $1" 499 die "${FUNCNAME}(): Unrecognized option '$1'"
218 ;; 500 ;;
219 *) 501 *)
220 break 502 break
221 ;; 503 ;;
222 esac 504 esac
223 shift 505 shift
224 done 506 done
225 507
508 if [[ -n "${source_dir}" && "${separate_build_dirs}" == 0 ]]; then
509 die "${FUNCNAME}(): '--source-dir' option can be specified only with '--separate-build-dirs' option"
510 fi
511
512 if [[ "${default_function}" == "0" ]]; then
226 if [[ "$#" -eq "0" ]]; then 513 if [[ "$#" -eq 0 ]]; then
227 die "${FUNCNAME}(): Missing function name" 514 die "${FUNCNAME}(): Missing function name"
228 fi 515 fi
229 function="$1" 516 function="$1"
230 shift 517 shift
518
519 if [[ -z "$(type -t "${function}")" ]]; then
520 die "${FUNCNAME}(): '${function}' function is not defined"
521 fi
522 else
523 if [[ "$#" -ne "0" ]]; then
524 die "${FUNCNAME}(): '--default-function' option and function name cannot be specified simultaneously"
525 fi
526 if has "${EAPI:-0}" 0 1; then
527 die "${FUNCNAME}(): '--default-function' option cannot be used in this EAPI"
528 fi
529
530 if [[ "${EBUILD_PHASE}" == "configure" ]]; then
531 if has "${EAPI}" 2 3; then
532 python_default_function() {
533 econf
534 }
535 else
536 python_default_function() {
537 nonfatal econf
538 }
539 fi
540 elif [[ "${EBUILD_PHASE}" == "compile" ]]; then
541 python_default_function() {
542 emake
543 }
544 elif [[ "${EBUILD_PHASE}" == "test" ]]; then
545 python_default_function() {
546 if emake -j1 -n check &> /dev/null; then
547 emake -j1 check
548 elif emake -j1 -n test &> /dev/null; then
549 emake -j1 test
550 fi
551 }
552 elif [[ "${EBUILD_PHASE}" == "install" ]]; then
553 python_default_function() {
554 emake DESTDIR="${D}" install
555 }
556 else
557 die "${FUNCNAME}(): '--default-function' option cannot be used in this ebuild phase"
558 fi
559 function="python_default_function"
560 fi
231 561
232 if [[ "${quiet}" == "0" ]]; then 562 if [[ "${quiet}" == "0" ]]; then
233 [[ "${EBUILD_PHASE}" == "setup" ]] && action="Setting up" 563 [[ "${EBUILD_PHASE}" == "setup" ]] && action="Setting up"
234 [[ "${EBUILD_PHASE}" == "unpack" ]] && action="Unpacking" 564 [[ "${EBUILD_PHASE}" == "unpack" ]] && action="Unpacking"
235 [[ "${EBUILD_PHASE}" == "prepare" ]] && action="Preparation" 565 [[ "${EBUILD_PHASE}" == "prepare" ]] && action="Preparation"
264 else 594 else
265 action_message="${action} of ${CATEGORY}/${PF} with Python ${PYTHON_ABI}..." 595 action_message="${action} of ${CATEGORY}/${PF} with Python ${PYTHON_ABI}..."
266 fi 596 fi
267 echo " ${GREEN}*${NORMAL} ${BLUE}${action_message}${NORMAL}" 597 echo " ${GREEN}*${NORMAL} ${BLUE}${action_message}${NORMAL}"
268 fi 598 fi
599
269 if [[ "${separate_build_dirs}" == "1" ]]; then 600 if [[ "${separate_build_dirs}" == "1" ]]; then
270 pushd "${S}-${PYTHON_ABI}" > /dev/null || die "pushd failed" 601 if [[ -n "${source_dir}" ]]; then
602 export BUILDDIR="${S}/${source_dir}-${PYTHON_ABI}"
603 else
604 export BUILDDIR="${S}-${PYTHON_ABI}"
271 fi 605 fi
272 if ! EPYTHON="$(get_python)" "${function}" "$@"; then 606 pushd "${BUILDDIR}" > /dev/null || die "pushd failed"
607 else
608 export BUILDDIR="${S}"
609 fi
610
611 previous_directory="$(pwd)"
612 previous_directory_stack="$(dirs -p)"
613 previous_directory_stack_length="$(dirs -p | wc -l)"
614
615 if ! has "${EAPI}" 0 1 2 3 && has "${PYTHON_ABI}" ${FAILURE_TOLERANT_PYTHON_ABIS}; then
616 EPYTHON="$(PYTHON)" nonfatal "${function}" "$@"
617 else
618 EPYTHON="$(PYTHON)" "${function}" "$@"
619 fi
620
621 if [[ "$?" != "0" ]]; then
273 if [[ -n "${failure_message_template}" ]]; then 622 if [[ -n "${failure_message_template}" ]]; then
274 failure_message="$(eval echo -n "${failure_message_template}")" 623 failure_message="$(eval echo -n "${failure_message_template}")"
275 else 624 else
276 failure_message="${action} failed with Python ${PYTHON_ABI} in ${function}() function" 625 failure_message="${action} failed with Python ${PYTHON_ABI} in ${function}() function"
277 fi 626 fi
278 if [[ "${nonfatal}" == "1" ]] || has "${PYTHON_ABI}" ${FAILURE_TOLERANT_PYTHON_ABIS}; then 627
279 local ABI enabled_PYTHON_ABIS 628 if [[ "${nonfatal}" == "1" ]]; then
280 for ABI in ${PYTHON_ABIS}; do
281 [[ "${ABI}" != "${PYTHON_ABI}" ]] && enabled_PYTHON_ABIS+=" ${ABI}"
282 done
283 export PYTHON_ABIS="${enabled_PYTHON_ABIS# }"
284 if [[ "${quiet}" == "0" ]]; then 629 if [[ "${quiet}" == "0" ]]; then
285 ewarn "${RED}${failure_message}${NORMAL}" 630 ewarn "${RED}${failure_message}${NORMAL}"
286 fi 631 fi
632 elif has "${PYTHON_ABI}" ${FAILURE_TOLERANT_PYTHON_ABIS}; then
633 if [[ "${EBUILD_PHASE}" != "test" ]] || ! has test-fail-continue ${FEATURES}; then
634 local enabled_PYTHON_ABIS= other_PYTHON_ABI
635 for other_PYTHON_ABI in ${PYTHON_ABIS}; do
636 [[ "${other_PYTHON_ABI}" != "${PYTHON_ABI}" ]] && enabled_PYTHON_ABIS+="${enabled_PYTHON_ABIS:+ }${other_PYTHON_ABI}"
637 done
638 export PYTHON_ABIS="${enabled_PYTHON_ABIS}"
639 fi
640 if [[ "${quiet}" == "0" ]]; then
641 ewarn "${RED}${failure_message}${NORMAL}"
642 fi
643 if [[ -z "${PYTHON_ABIS}" ]]; then
644 die "${function}() function failed with all enabled versions of Python"
645 fi
287 else 646 else
288 die "${failure_message}" 647 die "${failure_message}"
289 fi 648 fi
290 fi 649 fi
650
651 # Ensure that directory stack has not been decreased.
652 if [[ "$(dirs -p | wc -l)" -lt "${previous_directory_stack_length}" ]]; then
653 die "Directory stack decreased illegally"
654 fi
655
656 # Avoid side effects of earlier returning from the specified function.
657 while [[ "$(dirs -p | wc -l)" -gt "${previous_directory_stack_length}" ]]; do
658 popd > /dev/null || die "popd failed"
659 done
660
661 # Ensure that the bottom part of directory stack has not been changed. Restore
662 # previous directory (from before running of the specified function) before
663 # comparison of directory stacks to avoid mismatch of directory stacks after
664 # potential using of 'cd' to change current directory. Restoration of previous
665 # directory allows to safely use 'cd' to change current directory in the
666 # specified function without changing it back to original directory.
667 cd "${previous_directory}"
668 if [[ "$(dirs -p)" != "${previous_directory_stack}" ]]; then
669 die "Directory stack changed illegally"
670 fi
671
291 if [[ "${separate_build_dirs}" == "1" ]]; then 672 if [[ "${separate_build_dirs}" == "1" ]]; then
292 popd > /dev/null || die "popd failed" 673 popd > /dev/null || die "popd failed"
293 fi 674 fi
675 unset BUILDDIR
294 done 676 done
295}
296 677
678 if [[ "${default_function}" == "1" ]]; then
679 unset -f python_default_function
680 fi
681}
682
683# @FUNCTION: python_convert_shebangs
684# @USAGE: [-q|--quiet] [-r|--recursive] [-x|--only-executables] [--] <Python_version> <file|directory> [files|directories]
685# @DESCRIPTION:
686# Convert shebangs in specified files. Directories can be specified only with --recursive option.
687python_convert_shebangs() {
688 local argument file files=() only_executables="0" python_version quiet="0" recursive="0"
689
690 while (($#)); do
691 case "$1" in
692 -r|--recursive)
693 recursive="1"
694 ;;
695 -q|--quiet)
696 quiet="1"
697 ;;
698 -x|--only-executables)
699 only_executables="1"
700 ;;
701 --)
702 break
703 ;;
704 -*)
705 die "${FUNCNAME}(): Unrecognized option '$1'"
706 ;;
707 *)
708 break
709 ;;
710 esac
711 shift
712 done
713
714 if [[ "$#" -eq 0 ]]; then
715 die "${FUNCNAME}(): Missing Python version and files or directories"
716 elif [[ "$#" -eq 1 ]]; then
717 die "${FUNCNAME}(): Missing files or directories"
718 fi
719
720 python_version="$1"
721 shift
722
723 for argument in "$@"; do
724 if [[ ! -e "${argument}" ]]; then
725 die "${FUNCNAME}(): '${argument}' does not exist"
726 elif [[ -f "${argument}" ]]; then
727 files+=("${argument}")
728 elif [[ -d "${argument}" ]]; then
729 if [[ "${recursive}" == "1" ]]; then
730 if [[ "${only_executables}" == "1" ]]; then
731 files+=($(find "${argument}" -perm /111 -type f))
732 else
733 files+=($(find "${argument}" -type f))
734 fi
735 else
736 die "${FUNCNAME}(): '${argument}' is not a regular file"
737 fi
738 else
739 die "${FUNCNAME}(): '${argument}' is not a regular file or a directory"
740 fi
741 done
742
743 for file in "${files[@]}"; do
744 file="${file#./}"
745 [[ "${only_executables}" == "1" && ! -x "${file}" ]] && continue
746
747 if [[ "$(head -n1 "${file}")" =~ ^'#!'.*python ]]; then
748 if [[ "${quiet}" == "0" ]]; then
749 einfo "Converting shebang in '${file}'"
750 fi
751 sed -e "1s/python\([[:digit:]]\+\(\.[[:digit:]]\+\)\?\)\?/python${python_version}/" -i "${file}" || die "Conversion of shebang in '${file}' failed"
752
753 # Delete potential whitespace after "#!".
754 sed -e '1s/\(^#!\)[[:space:]]*/\1/' -i "${file}" || die "sed '${file}' failed"
755 fi
756 done
757}
758
759# @FUNCTION: python_generate_wrapper_scripts
760# @USAGE: [-E|--respect-EPYTHON] [-f|--force] [-q|--quiet] [--] <file> [files]
761# @DESCRIPTION:
762# Generate wrapper scripts. Existing files are overwritten only with --force option.
763# If --respect-EPYTHON option is specified, then generated wrapper scripts will
764# respect EPYTHON variable at run time.
765python_generate_wrapper_scripts() {
766 local eselect_python_option file force="0" quiet="0" PYTHON_ABI python2_enabled="0" python2_supported_versions python3_enabled="0" python3_supported_versions respect_EPYTHON="0"
767 python2_supported_versions="2.4 2.5 2.6 2.7"
768 python3_supported_versions="3.0 3.1 3.2"
769
770 while (($#)); do
771 case "$1" in
772 -E|--respect-EPYTHON)
773 respect_EPYTHON="1"
774 ;;
775 -f|--force)
776 force="1"
777 ;;
778 -q|--quiet)
779 quiet="1"
780 ;;
781 --)
782 break
783 ;;
784 -*)
785 die "${FUNCNAME}(): Unrecognized option '$1'"
786 ;;
787 *)
788 break
789 ;;
790 esac
791 shift
792 done
793
794 if [[ "$#" -eq 0 ]]; then
795 die "${FUNCNAME}(): Missing arguments"
796 fi
797
798 validate_PYTHON_ABIS
799 for PYTHON_ABI in ${python2_supported_versions}; do
800 if has "${PYTHON_ABI}" ${PYTHON_ABIS}; then
801 python2_enabled="1"
802 fi
803 done
804 for PYTHON_ABI in ${python3_supported_versions}; do
805 if has "${PYTHON_ABI}" ${PYTHON_ABIS}; then
806 python3_enabled="1"
807 fi
808 done
809
810 if [[ "${python2_enabled}" == "1" && "${python3_enabled}" == "1" ]]; then
811 eselect_python_option=
812 elif [[ "${python2_enabled}" == "1" && "${python3_enabled}" == "0" ]]; then
813 eselect_python_option="--python2"
814 elif [[ "${python2_enabled}" == "0" && "${python3_enabled}" == "1" ]]; then
815 eselect_python_option="--python3"
816 else
817 die "${FUNCNAME}(): Unsupported environment"
818 fi
819
820 for file in "$@"; do
821 if [[ -f "${file}" && "${force}" == "0" ]]; then
822 die "${FUNCNAME}(): '$1' already exists"
823 fi
824
825 if [[ "${quiet}" == "0" ]]; then
826 einfo "Generating '${file#${D%/}}' wrapper script"
827 fi
828
829 cat << EOF > "${file}"
830#!/usr/bin/env python
831# Gentoo '${file##*/}' wrapper script
832
833import os
834import re
835import subprocess
836import sys
837
838EPYTHON_re = re.compile(r"^python(\d+\.\d+)$")
839
840EOF
841 if [[ "$?" != "0" ]]; then
842 die "${FUNCNAME}(): Generation of '$1' failed"
843 fi
844 if [[ "${respect_EPYTHON}" == "1" ]]; then
845 cat << EOF >> "${file}"
846EPYTHON = os.environ.get("EPYTHON")
847if EPYTHON:
848 EPYTHON_matched = EPYTHON_re.match(EPYTHON)
849 if EPYTHON_matched:
850 PYTHON_ABI = EPYTHON_matched.group(1)
851 else:
852 sys.stderr.write("EPYTHON variable has unrecognized value '%s'\n" % EPYTHON)
853 sys.exit(1)
854else:
855 try:
856 eselect_process = subprocess.Popen(["/usr/bin/eselect", "python", "show"${eselect_python_option:+, $(echo "\"")}${eselect_python_option}${eselect_python_option:+$(echo "\"")}], stdout=subprocess.PIPE)
857 if eselect_process.wait() != 0:
858 raise ValueError
859 except (OSError, ValueError):
860 sys.stderr.write("Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n")
861 sys.exit(1)
862
863 eselect_output = eselect_process.stdout.read()
864 if not isinstance(eselect_output, str):
865 # Python 3
866 eselect_output = eselect_output.decode()
867
868 EPYTHON_matched = EPYTHON_re.match(eselect_output)
869 if EPYTHON_matched:
870 PYTHON_ABI = EPYTHON_matched.group(1)
871 else:
872 sys.stderr.write("'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s" % eselect_output)
873 sys.exit(1)
874EOF
875 if [[ "$?" != "0" ]]; then
876 die "${FUNCNAME}(): Generation of '$1' failed"
877 fi
878 else
879 cat << EOF >> "${file}"
880try:
881 eselect_process = subprocess.Popen(["/usr/bin/eselect", "python", "show"${eselect_python_option:+, $(echo "\"")}${eselect_python_option}${eselect_python_option:+$(echo "\"")}], stdout=subprocess.PIPE)
882 if eselect_process.wait() != 0:
883 raise ValueError
884except (OSError, ValueError):
885 sys.stderr.write("Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n")
886 sys.exit(1)
887
888eselect_output = eselect_process.stdout.read()
889if not isinstance(eselect_output, str):
890 # Python 3
891 eselect_output = eselect_output.decode()
892
893EPYTHON_matched = EPYTHON_re.match(eselect_output)
894if EPYTHON_matched:
895 PYTHON_ABI = EPYTHON_matched.group(1)
896else:
897 sys.stderr.write("'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s" % eselect_output)
898 sys.exit(1)
899EOF
900 if [[ "$?" != "0" ]]; then
901 die "${FUNCNAME}(): Generation of '$1' failed"
902 fi
903 fi
904 cat << EOF >> "${file}"
905
906os.environ["PYTHON_PROCESS_NAME"] = sys.argv[0]
907target_executable = "%s-%s" % (os.path.realpath(sys.argv[0]), PYTHON_ABI)
908if not os.path.exists(target_executable):
909 sys.stderr.write("'%s' does not exist\n" % target_executable)
910 sys.exit(1)
911
912os.execv(target_executable, sys.argv)
913EOF
914 if [[ "$?" != "0" ]]; then
915 die "${FUNCNAME}(): Generation of '$1' failed"
916 fi
917 fperms +x "${file#${D%/}}" || die "fperms '${file}' failed"
918 done
919}
297 920
298# @ECLASS-VARIABLE: PYTHON_USE_WITH 921# @ECLASS-VARIABLE: PYTHON_USE_WITH
299# @DESCRIPTION: 922# @DESCRIPTION:
300# Set this to a space separated list of use flags 923# Set this to a space separated list of use flags
301# the python slot in use must be built with. 924# the python slot in use must be built with.
313 936
314# @FUNCTION: python_pkg_setup 937# @FUNCTION: python_pkg_setup
315# @DESCRIPTION: 938# @DESCRIPTION:
316# Makes sure PYTHON_USE_WITH or PYTHON_USE_WITH_OR listed use flags 939# Makes sure PYTHON_USE_WITH or PYTHON_USE_WITH_OR listed use flags
317# are respected. Only exported if one of those variables is set. 940# are respected. Only exported if one of those variables is set.
318if ! has ${EAPI} 0 1 && [[ -n ${PYTHON_USE_WITH} || -n ${PYTHON_USE_WITH_OR} ]]; then 941if ! has "${EAPI:-0}" 0 1 && [[ -n ${PYTHON_USE_WITH} || -n ${PYTHON_USE_WITH_OR} ]]; then
942 python_pkg_setup() {
319 python_pkg_setup_fail() { 943 python_pkg_setup_fail() {
320 eerror "${1}" 944 eerror "${1}"
321 die "${1}" 945 die "${1}"
946 }
947
948 [[ ${PYTHON_USE_WITH_OPT} ]] && use !${PYTHON_USE_WITH_OPT} && return
949
950 python_pkg_setup_check_USE_flags() {
951 local pyatom use
952 if [[ -n "${PYTHON_ABI}" ]]; then
953 pyatom="dev-lang/python:${PYTHON_ABI}"
954 else
955 pyatom="dev-lang/python:$(PYTHON -A --ABI)"
956 fi
957
958 for use in ${PYTHON_USE_WITH}; do
959 if ! has_version "${pyatom}[${use}]"; then
960 python_pkg_setup_fail "Please rebuild ${pyatom} with the following USE flags enabled: ${PYTHON_USE_WITH}"
961 fi
962 done
963
964 for use in ${PYTHON_USE_WITH_OR}; do
965 if has_version "${pyatom}[${use}]"; then
966 return
967 fi
968 done
969
970 if [[ ${PYTHON_USE_WITH_OR} ]]; then
971 python_pkg_setup_fail "Please rebuild ${pyatom} with at least one of the following USE flags enabled: ${PYTHON_USE_WITH_OR}"
972 fi
973 }
974
975 if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
976 python_execute_function -q python_pkg_setup_check_USE_flags
977 else
978 python_pkg_setup_check_USE_flags
979 fi
322 } 980 }
323 981
324 python_pkg_setup() {
325 [[ ${PYTHON_USE_WITH_OPT} ]] && use !${PYTHON_USE_WITH_OPT} && return
326
327 python_version
328 local failed
329 local pyatom="dev-lang/python:${PYVER}"
330
331 for use in ${PYTHON_USE_WITH}; do
332 if ! has_version "${pyatom}[${use}]"; then
333 python_pkg_setup_fail \
334 "Please rebuild ${pyatom} with use flags: ${PYTHON_USE_WITH}"
335 fi
336 done
337
338 for use in ${PYTHON_USE_WITH_OR}; do
339 if has_version "${pyatom}[${use}]"; then
340 return
341 fi
342 done
343
344 if [[ ${PYTHON_USE_WITH_OR} ]]; then
345 python_pkg_setup_fail \
346 "Please rebuild ${pyatom} with one of: ${PYTHON_USE_WITH_OR}"
347 fi
348 }
349
350 EXPORT_FUNCTIONS pkg_setup 982 EXPORT_FUNCTIONS pkg_setup
351 983
352 if [[ ${PYTHON_USE_WITH} ]]; then 984 if [[ -n "${PYTHON_USE_WITH}" ]]; then
353 PYTHON_USE_WITH_ATOM="${PYTHON_ATOM}[${PYTHON_USE_WITH/ /,}]" 985 PYTHON_USE_WITH_ATOM="${PYTHON_ATOM}[${PYTHON_USE_WITH/ /,}]"
354 elif [[ ${PYTHON_USE_WITH_OR} ]]; then 986 elif [[ -n "${PYTHON_USE_WITH_OR}" ]]; then
355 PYTHON_USE_WITH_ATOM="|| ( " 987 PYTHON_USE_WITH_ATOM="|| ( "
356 for use in ${PYTHON_USE_WITH_OR}; do 988 for use in ${PYTHON_USE_WITH_OR}; do
357 PYTHON_USE_WITH_ATOM=" 989 PYTHON_USE_WITH_ATOM+=" ${PYTHON_ATOM}[${use}]"
358 ${PYTHON_USE_WITH_ATOM}
359 ${PYTHON_ATOM}[${use}]"
360 done 990 done
361 PYTHON_USE_WITH_ATOM="${PYTHON_USE_WITH_ATOM} )" 991 unset use
992 PYTHON_USE_WITH_ATOM+=" )"
362 fi 993 fi
363 if [[ ${PYTHON_USE_WITH_OPT} ]]; then 994 if [[ -n "${PYTHON_USE_WITH_OPT}" ]]; then
364 PYTHON_USE_WITH_ATOM="${PYTHON_USE_WITH_OPT}? ( ${PYTHON_USE_WITH_ATOM} )" 995 PYTHON_USE_WITH_ATOM="${PYTHON_USE_WITH_OPT}? ( ${PYTHON_USE_WITH_ATOM} )"
365 fi 996 fi
366 DEPEND="${PYTHON_USE_WITH_ATOM}" 997 DEPEND+=" ${PYTHON_USE_WITH_ATOM}"
367 RDEPEND="${PYTHON_USE_WITH_ATOM}" 998 RDEPEND+=" ${PYTHON_USE_WITH_ATOM}"
368fi 999fi
369 1000
1001# @ECLASS-VARIABLE: PYTHON_DEFINE_DEFAULT_FUNCTIONS
1002# @DESCRIPTION:
1003# Set this to define default functions for the following ebuild phases:
1004# src_prepare, src_configure, src_compile, src_test, src_install.
1005if ! has "${EAPI:-0}" 0 1 && [[ -n "${PYTHON_DEFINE_DEFAULT_FUNCTIONS}" ]]; then
1006 python_src_prepare() {
1007 python_copy_sources
1008 }
1009
1010 for python_default_function in src_configure src_compile src_test src_install; do
1011 eval "python_${python_default_function}() { python_execute_function -d -s; }"
1012 done
1013 unset python_default_function
1014
1015 EXPORT_FUNCTIONS src_prepare src_configure src_compile src_test src_install
1016fi
1017
370# @FUNCTION: python_disable_pyc 1018# @FUNCTION: python_disable_pyc
371# @DESCRIPTION: 1019# @DESCRIPTION:
372# Tells python not to automatically recompile modules to .pyc/.pyo 1020# Tell Python not to automatically recompile modules to .pyc/.pyo
373# even if the timestamps/version stamps don't match. This is done 1021# even if the timestamps/version stamps do not match. This is done
374# to protect sandbox. 1022# to protect sandbox.
375#
376# note: supported by >=dev-lang/python-2.2.3-r3 only.
377#
378python_disable_pyc() { 1023python_disable_pyc() {
379 export PYTHONDONTWRITEBYTECODE=1 # For 2.6 and above 1024 export PYTHONDONTWRITEBYTECODE="1"
380 export PYTHON_DONTCOMPILE=1 # For 2.5 and below
381} 1025}
382 1026
383# @FUNCTION: python_enable_pyc 1027# @FUNCTION: python_enable_pyc
384# @DESCRIPTION: 1028# @DESCRIPTION:
385# Tells python to automatically recompile modules to .pyc/.pyo if the 1029# Tell Python to automatically recompile modules to .pyc/.pyo if the
386# timestamps/version stamps change 1030# timestamps/version stamps have changed.
387python_enable_pyc() { 1031python_enable_pyc() {
388 unset PYTHONDONTWRITEBYTECODE 1032 unset PYTHONDONTWRITEBYTECODE
389 unset PYTHON_DONTCOMPILE
390} 1033}
391
392python_disable_pyc
393 1034
394# @FUNCTION: python_need_rebuild 1035# @FUNCTION: python_need_rebuild
395# @DESCRIPTION: Run without arguments, specifies that the package should be 1036# @DESCRIPTION: Run without arguments, specifies that the package should be
396# rebuilt after a python upgrade. 1037# rebuilt after a python upgrade.
1038# Do not use this function in ebuilds of packages supporting installation
1039# for multiple versions of Python.
397python_need_rebuild() { 1040python_need_rebuild() {
398 python_version 1041 export PYTHON_NEED_REBUILD="$(PYTHON -A --ABI)"
399 export PYTHON_NEED_REBUILD=${PYVER}
400} 1042}
401 1043
402# @FUNCTION: python_get_includedir 1044# @FUNCTION: python_get_includedir
403# @DESCRIPTION: 1045# @DESCRIPTION:
404# Run without arguments, returns the Python include directory. 1046# Run without arguments, returns the Python include directory.
405python_get_includedir() { 1047python_get_includedir() {
406 if [[ -n "${PYTHON_ABI}" ]]; then 1048 if [[ -n "${PYTHON_ABI}" ]]; then
407 echo "/usr/include/python${PYTHON_ABI}" 1049 echo "/usr/include/python${PYTHON_ABI}"
408 else 1050 else
409 python_version
410 echo "/usr/include/python${PYVER}" 1051 echo "/usr/include/python$(PYTHON -A --ABI)"
411 fi 1052 fi
412} 1053}
413 1054
414# @FUNCTION: python_get_libdir 1055# @FUNCTION: python_get_libdir
415# @DESCRIPTION: 1056# @DESCRIPTION:
416# Run without arguments, returns the Python library directory. 1057# Run without arguments, returns the Python library directory.
417python_get_libdir() { 1058python_get_libdir() {
418 if [[ -n "${PYTHON_ABI}" ]]; then 1059 if [[ -n "${PYTHON_ABI}" ]]; then
419 echo "/usr/$(get_libdir)/python${PYTHON_ABI}" 1060 echo "/usr/$(get_libdir)/python${PYTHON_ABI}"
420 else 1061 else
421 python_version
422 echo "/usr/$(get_libdir)/python${PYVER}" 1062 echo "/usr/$(get_libdir)/python$(PYTHON -A --ABI)"
423 fi 1063 fi
424} 1064}
425 1065
426# @FUNCTION: python_get_sitedir 1066# @FUNCTION: python_get_sitedir
427# @DESCRIPTION: 1067# @DESCRIPTION:
428# Run without arguments, returns the Python site-packages directory. 1068# Run without arguments, returns the Python site-packages directory.
429python_get_sitedir() { 1069python_get_sitedir() {
430 echo "$(python_get_libdir)/site-packages" 1070 echo "$(python_get_libdir)/site-packages"
431}
432
433# @FUNCTION: python_makesym
434# @DESCRIPTION:
435# Run without arguments, it will create the /usr/bin/python symlinks
436# to the latest installed version
437python_makesym() {
438 alternatives_auto_makesym "/usr/bin/python" "python[0-9].[0-9]"
439 alternatives_auto_makesym "/usr/bin/python2" "python2.[0-9]"
440} 1071}
441 1072
442# @FUNCTION: python_tkinter_exists 1073# @FUNCTION: python_tkinter_exists
443# @DESCRIPTION: 1074# @DESCRIPTION:
444# Run without arguments, checks if python was compiled with Tkinter 1075# Run without arguments, checks if python was compiled with Tkinter
488 1119
489 # Check if phase is pkg_postinst() 1120 # Check if phase is pkg_postinst()
490 [[ ${EBUILD_PHASE} != postinst ]] &&\ 1121 [[ ${EBUILD_PHASE} != postinst ]] &&\
491 die "${FUNCNAME} should only be run in pkg_postinst()" 1122 die "${FUNCNAME} should only be run in pkg_postinst()"
492 1123
493 # allow compiling for older python versions
494 if [[ "${PYTHON_OVERRIDE_PYVER}" ]]; then
495 PYVER=${PYTHON_OVERRIDE_PYVER}
496 else
497 python_version
498 fi
499
500 # strip trailing slash 1124 # strip trailing slash
501 myroot="${ROOT%/}" 1125 myroot="${ROOT%/}"
502 1126
503 # respect ROOT 1127 # respect ROOT
504 for f in "$@"; do 1128 for f in "$@"; do
505 [[ -f "${myroot}/${f}" ]] && myfiles+=("${myroot}/${f}") 1129 [[ -f "${myroot}/${f}" ]] && myfiles+=("${myroot}/${f}")
506 done 1130 done
507 1131
508 if ((${#myfiles[@]})); then 1132 if ((${#myfiles[@]})); then
509 python${PYVER} ${myroot}/usr/$(get_libdir)/python${PYVER}/py_compile.py "${myfiles[@]}" 1133 "$(PYTHON -A)" "${myroot}$(python_get_libdir)/py_compile.py" "${myfiles[@]}"
510 python${PYVER} -O ${myroot}/usr/$(get_libdir)/python${PYVER}/py_compile.py "${myfiles[@]}" 1134 "$(PYTHON -A)" -O "${myroot}$(python_get_libdir)/py_compile.py" "${myfiles[@]}" &> /dev/null
511 else 1135 else
512 ewarn "No files to compile!" 1136 ewarn "No files to compile!"
513 fi 1137 fi
514} 1138}
515 1139
549 ;; 1173 ;;
550 -*) 1174 -*)
551 ewarn "${FUNCNAME}: Ignoring compile option $1" 1175 ewarn "${FUNCNAME}: Ignoring compile option $1"
552 ;; 1176 ;;
553 *) 1177 *)
554 if [[ "$1" =~ ^/usr/lib(32|64)?/python[[:digit:]]+\.[[:digit:]]+ ]]; then 1178 if ! _python_implementation && [[ "$1" =~ ^/usr/lib(32|64)?/python[[:digit:]]+\.[[:digit:]]+ ]]; then
555 die "${FUNCNAME} doesn't support absolute paths of directories/files in site-packages directories" 1179 die "${FUNCNAME} does not support absolute paths of directories/files in site-packages directories"
556 elif [[ "$1" =~ ^/ ]]; then 1180 elif [[ "$1" =~ ^/ ]]; then
557 if [[ -d "${root}/$1" ]]; then 1181 if [[ -d "${root}/$1" ]]; then
558 other_dirs+=("${root}/$1") 1182 other_dirs+=("${root}/$1")
559 elif [[ -f "${root}/$1" ]]; then 1183 elif [[ -f "${root}/$1" ]]; then
560 other_files+=("${root}/$1") 1184 other_files+=("${root}/$1")
561 elif [[ -e "${root}/$1" ]]; then 1185 elif [[ -e "${root}/$1" ]]; then
562 ewarn "'${root}/$1' is not a file or a directory!" 1186 ewarn "'${root}/$1' is not a file or a directory!"
563 else 1187 else
564 ewarn "'${root}/$1' doesn't exist!" 1188 ewarn "'${root}/$1' does not exist!"
565 fi 1189 fi
566 else 1190 else
567 for PYTHON_ABI in ${PYTHON_ABIS}; do 1191 for PYTHON_ABI in ${PYTHON_ABIS-${PYTHON_ABI-$(PYTHON -A --ABI)}}; do
568 if [[ -d "${root}/$(python_get_sitedir)/$1" ]]; then 1192 if [[ -d "${root}$(python_get_sitedir)/$1" ]]; then
569 site_packages_dirs+=("$1") 1193 site_packages_dirs+=("$1")
570 break 1194 break
571 elif [[ -f "${root}/$(python_get_sitedir)/$1" ]]; then 1195 elif [[ -f "${root}$(python_get_sitedir)/$1" ]]; then
572 site_packages_files+=("$1") 1196 site_packages_files+=("$1")
573 break 1197 break
574 elif [[ -e "${root}/$(python_get_sitedir)/$1" ]]; then 1198 elif [[ -e "${root}$(python_get_sitedir)/$1" ]]; then
575 ewarn "'$1' is not a file or a directory!" 1199 ewarn "'$1' is not a file or a directory!"
576 else 1200 else
577 ewarn "'$1' doesn't exist!" 1201 ewarn "'$1' does not exist!"
578 fi 1202 fi
579 done 1203 done
580 fi 1204 fi
581 ;; 1205 ;;
582 esac 1206 esac
584 done 1208 done
585 1209
586 # Set additional options. 1210 # Set additional options.
587 options+=("-q") 1211 options+=("-q")
588 1212
589 for PYTHON_ABI in ${PYTHON_ABIS}; do 1213 for PYTHON_ABI in ${PYTHON_ABIS-${PYTHON_ABI-$(PYTHON -A --ABI)}}; do
590 if ((${#site_packages_dirs[@]})) || ((${#site_packages_files[@]})); then 1214 if ((${#site_packages_dirs[@]})) || ((${#site_packages_files[@]})); then
591 return_code="0" 1215 return_code="0"
592 ebegin "Compilation and optimization of Python modules for Python ${PYTHON_ABI}" 1216 ebegin "Compilation and optimization of Python modules for Python ${PYTHON_ABI}"
593 if ((${#site_packages_dirs[@]})); then 1217 if ((${#site_packages_dirs[@]})); then
594 for dir in "${site_packages_dirs[@]}"; do 1218 for dir in "${site_packages_dirs[@]}"; do
595 site_packages_absolute_dirs+=("${root}/$(python_get_sitedir)/${dir}") 1219 site_packages_absolute_dirs+=("${root}$(python_get_sitedir)/${dir}")
596 done 1220 done
597 "$(get_python)" "${root}/$(python_get_libdir)/compileall.py" "${options[@]}" "${site_packages_absolute_dirs[@]}" || return_code="1" 1221 "$(PYTHON)" "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${site_packages_absolute_dirs[@]}" || return_code="1"
598 "$(get_python)" -O "${root}/$(python_get_libdir)/compileall.py" "${options[@]}" "${site_packages_absolute_dirs[@]}" || return_code="1" 1222 "$(PYTHON)" -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${site_packages_absolute_dirs[@]}" &> /dev/null || return_code="1"
599 fi 1223 fi
600 if ((${#site_packages_files[@]})); then 1224 if ((${#site_packages_files[@]})); then
601 for file in "${site_packages_files[@]}"; do 1225 for file in "${site_packages_files[@]}"; do
602 site_packages_absolute_files+=("${root}/$(python_get_sitedir)/${file}") 1226 site_packages_absolute_files+=("${root}$(python_get_sitedir)/${file}")
603 done 1227 done
604 "$(get_python)" "${root}/$(python_get_libdir)/py_compile.py" "${site_packages_absolute_files[@]}" || return_code="1" 1228 "$(PYTHON)" "${root}$(python_get_libdir)/py_compile.py" "${site_packages_absolute_files[@]}" || return_code="1"
605 "$(get_python)" -O "${root}/$(python_get_libdir)/py_compile.py" "${site_packages_absolute_files[@]}" || return_code="1" 1229 "$(PYTHON)" -O "${root}$(python_get_libdir)/py_compile.py" "${site_packages_absolute_files[@]}" &> /dev/null || return_code="1"
606 fi 1230 fi
607 eend "${return_code}" 1231 eend "${return_code}"
608 fi 1232 fi
609 unset site_packages_absolute_dirs site_packages_absolute_files 1233 unset site_packages_absolute_dirs site_packages_absolute_files
610 done 1234 done
611 1235
612 # Don't use PYTHON_ABI in next calls to python_get_libdir(). 1236 # Do not use PYTHON_ABI in next calls to python_get_libdir().
613 unset PYTHON_ABI 1237 unset PYTHON_ABI
614 1238
615 if ((${#other_dirs[@]})) || ((${#other_files[@]})); then 1239 if ((${#other_dirs[@]})) || ((${#other_files[@]})); then
616 return_code="0" 1240 return_code="0"
617 ebegin "Compilation and optimization of Python modules placed outside of site-packages directories for Python ${PYVER}..." 1241 ebegin "Compilation and optimization of Python modules placed outside of site-packages directories for Python $(PYTHON -A --ABI)"
618 if ((${#other_dirs[@]})); then 1242 if ((${#other_dirs[@]})); then
619 python${PYVER} "${root}/$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" || return_code="1"
620 python${PYVER} -O "${root}/$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" || return_code="1" 1243 "$(PYTHON -A)" "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" || return_code="1"
1244 "$(PYTHON -A)" -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" &> /dev/null || return_code="1"
621 fi 1245 fi
622 if ((${#other_files[@]})); then 1246 if ((${#other_files[@]})); then
623 python${PYVER} "${root}/$(python_get_libdir)/py_compile.py" "${other_files[@]}" || return_code="1"
624 python${PYVER} -O "${root}/$(python_get_libdir)/py_compile.py" "${other_files[@]}" || return_code="1" 1247 "$(PYTHON -A)" "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" || return_code="1"
1248 "$(PYTHON -A)" -O "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" &> /dev/null || return_code="1"
625 fi 1249 fi
626 eend "${return_code}" 1250 eend "${return_code}"
627 fi 1251 fi
628 else 1252 else
629 local myroot mydirs=() myfiles=() myopts=() 1253 local myroot mydirs=() myfiles=() myopts=() return_code="0"
630 1254
631 # strip trailing slash 1255 # strip trailing slash
632 myroot="${ROOT%/}" 1256 myroot="${ROOT%/}"
633 1257
634 # respect ROOT and options passed to compileall.py 1258 # respect ROOT and options passed to compileall.py
651 # Files are passed to python_mod_compile which is ROOT-aware 1275 # Files are passed to python_mod_compile which is ROOT-aware
652 myfiles+=("$1") 1276 myfiles+=("$1")
653 elif [[ -e "${myroot}/$1" ]]; then 1277 elif [[ -e "${myroot}/$1" ]]; then
654 ewarn "${myroot}/$1 is not a file or directory!" 1278 ewarn "${myroot}/$1 is not a file or directory!"
655 else 1279 else
656 ewarn "${myroot}/$1 doesn't exist!" 1280 ewarn "${myroot}/$1 does not exist!"
657 fi 1281 fi
658 ;; 1282 ;;
659 esac 1283 esac
660 shift 1284 shift
661 done 1285 done
662 1286
663 # allow compiling for older python versions
664 if [ -n "${PYTHON_OVERRIDE_PYVER}" ]; then
665 PYVER=${PYTHON_OVERRIDE_PYVER}
666 else
667 python_version
668 fi
669
670 # set additional opts 1287 # set additional opts
671 myopts+=(-q) 1288 myopts+=(-q)
672 1289
673 ebegin "Byte compiling python modules for python-${PYVER} .." 1290 ebegin "Compilation and optimization of Python modules for Python $(PYTHON -A --ABI)"
674 if ((${#mydirs[@]})); then 1291 if ((${#mydirs[@]})); then
675 python${PYVER} \ 1292 "$(PYTHON -A)" "${myroot}$(python_get_libdir)/compileall.py" "${myopts[@]}" "${mydirs[@]}" || return_code="1"
676 "${myroot}"/usr/$(get_libdir)/python${PYVER}/compileall.py \ 1293 "$(PYTHON -A)" -O "${myroot}$(python_get_libdir)/compileall.py" "${myopts[@]}" "${mydirs[@]}" &> /dev/null || return_code="1"
677 "${myopts[@]}" "${mydirs[@]}"
678 python${PYVER} -O \
679 "${myroot}"/usr/$(get_libdir)/python${PYVER}/compileall.py \
680 "${myopts[@]}" "${mydirs[@]}"
681 fi 1294 fi
682 1295
683 if ((${#myfiles[@]})); then 1296 if ((${#myfiles[@]})); then
684 python_mod_compile "${myfiles[@]}" 1297 python_mod_compile "${myfiles[@]}"
685 fi 1298 fi
686 1299
687 eend $? 1300 eend "${return_code}"
688 fi 1301 fi
689} 1302}
690 1303
691# @FUNCTION: python_mod_cleanup 1304# @FUNCTION: python_mod_cleanup
692# @USAGE: [directory] 1305# @USAGE: [directory|file]
693# @DESCRIPTION: 1306# @DESCRIPTION:
694# Run with optional arguments, where arguments are directories of 1307# Run with optional arguments, where arguments are Python modules. If none given,
695# python modules. If none given, it will look in /usr/lib/python[0-9].[0-9]. 1308# it will look in /usr/lib/python[0-9].[0-9].
696# 1309#
697# It will recursively scan all compiled Python modules in the directories and 1310# It will recursively scan all compiled Python modules in the directories and
698# determine if they are orphaned (i.e. their corresponding .py files are missing.) 1311# determine if they are orphaned (i.e. their corresponding .py files are missing.)
699# If they are, then it will remove their corresponding .pyc and .pyo files. 1312# If they are, then it will remove their corresponding .pyc and .pyo files.
700# 1313#
701# This function should only be run in pkg_postrm(). 1314# This function should only be run in pkg_postrm().
702python_mod_cleanup() { 1315python_mod_cleanup() {
703 local PYTHON_ABI SEARCH_PATH=() root src_py 1316 local path py_file PYTHON_ABI SEARCH_PATH=() root
704 1317
705 # Check if phase is pkg_postrm(). 1318 # Check if phase is pkg_postrm().
706 [[ ${EBUILD_PHASE} != "postrm" ]] && die "${FUNCNAME} should only be run in pkg_postrm()" 1319 [[ ${EBUILD_PHASE} != "postrm" ]] && die "${FUNCNAME} should only be run in pkg_postrm()"
707 1320
708 # Strip trailing slash from ROOT. 1321 # Strip trailing slash from ROOT.
709 root="${ROOT%/}" 1322 root="${ROOT%/}"
710 1323
711 if (($#)); then 1324 if (($#)); then
712 if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then 1325 if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
713 while (($#)); do 1326 while (($#)); do
714 if [[ "$1" =~ ^/usr/lib(32|64)?/python[[:digit:]]+\.[[:digit:]]+ ]]; then 1327 if ! _python_implementation && [[ "$1" =~ ^/usr/lib(32|64)?/python[[:digit:]]+\.[[:digit:]]+ ]]; then
715 die "${FUNCNAME} doesn't support absolute paths of directories/files in site-packages directories" 1328 die "${FUNCNAME} does not support absolute paths of directories/files in site-packages directories"
716 elif [[ "$1" =~ ^/ ]]; then 1329 elif [[ "$1" =~ ^/ ]]; then
717 SEARCH_PATH+=("${root}/${1#/}") 1330 SEARCH_PATH+=("${root}/${1#/}")
718 else 1331 else
719 for PYTHON_ABI in ${PYTHON_ABIS}; do 1332 for PYTHON_ABI in ${PYTHON_ABIS-${PYTHON_ABI-$(PYTHON -A --ABI)}}; do
720 SEARCH_PATH+=("${root}/$(python_get_sitedir)/$1") 1333 SEARCH_PATH+=("${root}$(python_get_sitedir)/$1")
721 done 1334 done
722 fi 1335 fi
723 shift 1336 shift
724 done 1337 done
725 else 1338 else
726 SEARCH_PATH=("${@#/}") 1339 SEARCH_PATH=("${@#/}")
727 SEARCH_PATH=("${SEARCH_PATH[@]/#/${root}/}") 1340 SEARCH_PATH=("${SEARCH_PATH[@]/#/${root}/}")
728 fi 1341 fi
729 else 1342 else
730 SEARCH_PATH=("${root}"/usr/lib*/python*/site-packages) 1343 local dir sitedir
1344 for dir in "${root}"/usr/lib*; do
1345 if [[ -d "${dir}" && ! -L "${dir}" ]]; then
1346 for sitedir in "${dir}"/python*/site-packages; do
1347 if [[ -d "${sitedir}" ]]; then
1348 SEARCH_PATH+=("${sitedir}")
1349 fi
1350 done
1351 fi
1352 done
1353 fi
1354
1355 local BLUE CYAN NORMAL
1356 if [[ "${NOCOLOR:-false}" =~ ^(false|no)$ ]]; then
1357 BLUE=$'\e[1;34m'
1358 CYAN=$'\e[1;36m'
1359 NORMAL=$'\e[0m'
1360 else
1361 BLUE=
1362 CYAN=
1363 NORMAL=
731 fi 1364 fi
732 1365
733 for path in "${SEARCH_PATH[@]}"; do 1366 for path in "${SEARCH_PATH[@]}"; do
734 einfo "Cleaning orphaned Python bytecode from ${path} .." 1367 if [[ -d "${path}" ]]; then
735 find "${path}" -name '*.py[co]' -print0 | while read -rd ''; do 1368 find "${path}" -name '*.py[co]' -print0 | while read -rd ''; do
736 src_py="${REPLY%[co]}" 1369 py_file="${REPLY%[co]}"
737 [[ -f "${src_py}" ]] && continue 1370 [[ -f "${py_file}" || (! -f "${py_file}c" && ! -f "${py_file}o") ]] && continue
738 einfo "Purging ${src_py}[co]" 1371 einfo "${BLUE}<<< ${py_file}[co]${NORMAL}"
739 rm -f "${src_py}"[co] 1372 rm -f "${py_file}"[co]
740 done 1373 done
741 1374
742 # Attempt to remove directories that may be empty. 1375 # Attempt to delete directories, which may be empty.
743 find "${path}" -type d | sort -r | while read -r dir; do 1376 find "${path}" -type d | sort -r | while read -r dir; do
744 rmdir "${dir}" 2>/dev/null 1377 rmdir "${dir}" 2>/dev/null && einfo "${CYAN}<<< ${dir}${NORMAL}"
745 done 1378 done
1379 elif [[ "${path}" == *.py && ! -f "${path}" && (-f "${path}c" || -f "${path}o") ]]; then
1380 einfo "${BLUE}<<< ${path}[co]${NORMAL}"
1381 rm -f "${path}"[co]
1382 fi
746 done 1383 done
747} 1384}

Legend:
Removed from v.1.57  
changed lines
  Added in v.1.84

  ViewVC Help
Powered by ViewVC 1.1.20